<template>
  <el-dialog title="调整库存" :visible.sync="dialogVisible" width="750px" @close="cancelSubmit()">
    <div v-loading="loading">
      <div>
        <div class="fr mb20">
          <el-select v-model="stockType" style="width:100px;margin-right:10px">
            <el-option label="增加" :value="0"></el-option>
            <el-option label="减少" :value="1"></el-option>
          </el-select>
          <el-input placeholder="输入库存" style="width:85px;margin-right:10px" v-model="banthStock" precision="0" :min="0" :max="999999"></el-input>
          <el-button type="primary" @click="handleStock">批量填充</el-button>
        </div>
        <el-table :data="tableData" :span-method="objectSpanMethod" border>
          <el-table-column label="颜色" prop="color" width="90px">
            <template slot-scope="scope">{{ scope.row.color }}</template>
          </el-table-column>
          <el-table-column label="尺码" prop="size" width="90px">
            <template slot-scope="scope">{{ scope.row.size }}</template>
          </el-table-column>
          <el-table-column label="当前可占用" prop="remainedStock" width="100px">
            <template slot-scope="scope">{{ scope.row.remainedStock }}</template>
          </el-table-column>
          <el-table-column label="增加/减少" width="150px">
            <template slot-scope="scope">
              <el-select v-model="scope.row.stockType" style="width:100px">
                <el-option label="增加" :value="0"></el-option>
                <el-option label="减少" :value="1"></el-option>
              </el-select>
            </template>
          </el-table-column>
          <el-table-column label="库存">
            <template slot-scope="scope">
              <dm-input-amount width="200px" @change="changeSingleStock(scope.row.giftSkuId, scope.row.stock, scope.row.stockType)" v-model.trim="scope.row.stock" precision="0" :min="0" :max="999999"></dm-input-amount>
            </template>
          </el-table-column>
        </el-table>
      </div>
      <div>
        <el-select v-model="stockType" style="width:100px;display:inline-block;margin-right:10px">
          <el-option label="增加" :value="0"></el-option>
          <el-option label="减少" :value="1"></el-option>
        </el-select>
        <el-input-number v-model="stock" precision="0" :min="0" :max="999999"  style="width:300px"></el-input-number>
      </div>
      <el-input type="textarea" class="mt20" :rows="3" placeholder="请填入调整备注" v-model="textarea" :maxlength="240" show-word-limit></el-input>
    </div>
    <div slot="footer" class="dialog-footer">
      <el-button @click="cancelSubmit()">取消</el-button>
      <el-button type="primary" @click="submitProNanme()">确认</el-button>
    </div>
  </el-dialog>
</template>

<script>
// import request from '../service/request.js';
import api from '@/api/gift.js';
const { realStockUpdate } = api;
export default {
  props: {
    stockData: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  data() {
    return {
      dialogVisible: false,
      loading: false,
      // tableData: [],
      tableData: [
        {
          color: '红色',
          size: 'L',
          remainedStock: '10',
          giftSkuId: '1111',
          stock: '10',
          stockType: 1
        },
        {
          color: '红色',
          size: 'XL',
          remainedStock: '20',
          giftSkuId: '2222',
          stock: '20',
          stockType: 1
        },
        {
          color: '红色',
          size: 'M',
          remainedStock: '30',
          giftSkuId: '3333',
          stock: '12',
          stockType: 1
        },
        {
          color: '黑色',
          size: 'L',
          remainedStock: '10',
          giftSkuId: '4444',
          stock: '13',
          stockType: 1
        },
        {
          color: '黑色',
          size: 'M',
          remainedStock: '20',
          giftSkuId: '55555',
          stock: '14',
          stockType: 1
        }
      ],
      spanArr: [], // 用于存放每一行记录的合并数
      // costChangeObj: [], // 用于存放批量修改后的数据
      banthStock: '',
      stockType: 0,
      updateList: [],
      textarea: ''
    };
  },
  mounted() {
    this.dialogVisible = true;
    this.getData();
    this.getSpanArr(this.tableData);
  },
  methods: {
    getData(){
      console.log('获取成本数据');
    },
    submitProNanme() {
      if(this.loading) return;
      let params = {
        giftId: this.stockData.id,
        updateList: this.updateList,
        remark: this.textarea
      };
      this.loading = true;
      realStockUpdate(params).then(res =>{
        if(res.code === '0000'){
          this.dialogVisible = false;
          setInterval(() => {
            this.$emit('closeUpdateStock');
          }, 10);
          this.$message.success('修改成功');
        }else{
          this.$message.error(res.message);
        }
      }).finally(() => this.loading = false);
    },
    // 取消修改
    cancelSubmit() {
      this.dialogVisible = false;
      setInterval(() => {
        this.$emit('closeUpdateStock');
      }, 10);
    },
    // 合并单元格，行合并
    getSpanArr(data) {
      // data就是我们从后台拿到的数据
      for (let i = 0; i < data.length; i++) {
        if (i === 0) {
          this.spanArr.push(1);
          this.pos = 0;
        } else {
          // 判断当前元素与上一个元素是否相同
          if (data[i].color === data[i - 1].color) {
            this.spanArr[this.pos] += 1;
            this.spanArr.push(0);
          } else {
            this.spanArr.push(1);
            this.pos = i;
          }
        }
        // console.log(this.spanArr);
      }
    },
    objectSpanMethod({ row, column, rowIndex, columnIndex }) {
      // if (columnIndex === 0 || columnIndex === 1) {
      if (columnIndex === 0) {
        const _row = this.spanArr[rowIndex];
        const _col = _row > 0 ? 1 : 0;
        // console.log(`rowspan:${_row} colspan:${_col}`);
        return {
          // [0,0] 表示这一行不显示， [2,1]表示行的合并数
          rowspan: _row,
          colspan: _col
        };
      }
    },
    // 批量修改成本
    handleStock(){
      // for (let item in this.costChangeObj) {
      //   this.costChangeObj[item].costPrice = this.banthCost;
      //   // this.costChangeObj[item].stockType = this.stockType;
      // }
      this.updateList = [];
      // if(this.stockType === 1){
      //   this.tableData.forEach(item => {
      //     // item.stock = Number(item.stock) + Number(this.banthStock);
      //     item.stock = this.banthStock;
      //     item.stockType = this.stockType;
      //     this.updateList.push({ giftSkuId: item.giftSkuId, stock: item.stock, stockType: item.stockType });
      //   });
      // }else{
      //   this.tableData.forEach(item => {
      //     // item.stock = Number(item.stock) - Number(this.banthStock);
      //     item.stock = this.banthStock;
      //     item.stockType = this.stockType;
      //     this.updateList.push({ giftSkuId: item.giftSkuId, stock: item.stock, stockType: item.stockType });
      //   });
      // }
      this.tableData.forEach(item => {
        item.stock = this.banthStock;
        item.stockType = this.stockType;
        this.updateList.push({ giftSkuId: item.giftSkuId, stock: item.stock, stockType: item.stockType });
      });
      console.log(this.updateList);
    },
    changeSingleStock(id, stock, stockType){
      if(!stock){
        this.$message.error('请完善库存');
      }
      if(this.updateList.length > 0){
        let iii;
        let result = this.updateList.some((item, index) =>{
          if(item.giftSkuId == id){
            iii = index;
            return true;
          }
        });
        if(result){ // 如果存在
          this.updateList[iii].stock = stock;
        }else{
          this.updateList.push({ giftSkuId: id, stock: stock, stockType: stockType });
        }
      }else{
        this.updateList.push({ giftSkuId: id, stock: stock, stockType: stockType });
      }
      console.log(this.updateList);
    }
  }
};
</script>
<style scoped></style>
